`timescale 1ns/1ns
module testbench;

reg i_clk;
reg i_reset;

reg i_tInput_valid_in;
wire o_tInput_stall_out;

wire o_tOutput_valid_out;
reg i_tOutput_stall_in;

reg [31:0] i_x;
reg [31:0] i_y;
wire [31:0] o_z;

SmallPipeline trf(
   .i_clk(i_clk), 
   .i_reset(i_reset), 
   .i_tOutput_stall_in(i_tOutput_stall_in), 
   .i_x(i_x), 
   .i_y(i_y), 
   .o_z(o_z), 
   .i_tInput_valid_in(i_tInput_valid_in), 
   .o_tOutput_valid_out(o_tOutput_valid_out), 
   .o_tInput_stall_out(o_tInput_stall_out)
);

always 
   #5 i_clk = ~i_clk;

initial begin

   i_clk = 0;
   i_reset = 0;

   // Basic Reset
   i_tInput_valid_in = 0;
   i_tOutput_stall_in = 0;
   i_x = 32'd10; // Remember, this is for resetting.
   i_y = 32'd5;

   // This resets the internal logic
   #100 i_reset = 1;

   $display("-- starting --");
   
   while(1) begin

      i_tInput_valid_in = 1;
      i_x = i_x + 1;
      #10
      i_tInput_valid_in = 0;
      #10;

   end

   $stop;
   
end

always @(posedge o_tOutput_valid_out)
   $display("z = %d", o_z);

endmodule
