`timescale 1ns/1ns
module testbench;

reg i_clk;
reg i_reset;

reg i_tInput_valid_in;
wire o_tInput_stall_out;

wire o_tOutput_valid_out;
reg i_tOutput_stall_in;

reg [31:0] i_x_in;
wire [31:0] o_x_out;

TrivialRuleFiring trf(
   .i_clk(i_clk), 
   .i_reset(i_reset), 
   .i_tOutput_stall_in(i_tOutput_stall_in), 
   .i_x_in(i_x_in), 
   .i_tInput_valid_in(i_tInput_valid_in), 
   .o_tOutput_valid_out(o_tOutput_valid_out), 
   .o_tInput_stall_out(o_tInput_stall_out), 
   .o_x_out(o_x_out)
);

always 
   #5 i_clk = ~i_clk;

initial begin

   i_clk = 0;
   i_reset = 0;

   // Basic Reset
   i_tInput_valid_in = 0;
   i_tOutput_stall_in = 0;
   i_x_in = 32'd0; // Remember, this is for resetting.

   // This resets the internal logic
   #100 i_reset = 1;

   $display("-- starting --");
   
   while(1) begin

      i_tInput_valid_in = 1;
      i_x_in = i_x_in + 1;
      #10
      i_tInput_valid_in = 0;
      #10;

   end

   $stop;
   
end

always @(posedge o_tOutput_valid_out)
   $display("x_out = %d", o_x_out);

endmodule
