/****************************/
/* Accumulator              */
/* Generated by PyTDL       */
/* Thu Sep 24 19:53:20 2009 */
/****************************/

module Accumulator(i_clk, i_reset, i_value, o_tOutput_valid_out, o_sum_out, i_tInput_valid_in, o_tReset_stall_out, i_tReset_valid_in, i_sum, i_tOutput_stall_in, o_tInput_stall_out);
	input i_clk;
	input i_reset;

	input i_tInput_valid_in;
	output o_tInput_stall_out;
	input i_tReset_valid_in;
	output o_tReset_stall_out;

	output o_tOutput_valid_out;
	input i_tOutput_stall_in;

	/* --- DATA --- */
	input [31:0] i_sum;
	input [31:0] i_value;

	output [31:0] o_sum_out;

	wire [31:0] sum_out;

	wire [31:0] sum = i_sum;
	wire [31:0] value = i_value;




	/* -- FORK(2) 0x0 -- */
	wire fork0x0_valid_in;
	wire fork0x0_stall_out;
	wire fork0x0_valid_out0;
	wire fork0x0_stall_in0;
	wire fork0x0_valid_out1;
	wire fork0x0_stall_in1;
	fork2 fork0x0(.clk(i_clk), .valid_in(fork0x0_valid_in),
	              .stall_out(fork0x0_stall_out),
	              .valid_out0(fork0x0_valid_out0),
	              .stall_in0(fork0x0_stall_in0),
	              .valid_out1(fork0x0_valid_out1),
	              .stall_in1(fork0x0_stall_in1));
		/* -- data -- */
	wire [31:0] fork0x0_sum_o0;
	wire [31:0] fork0x0_sum_o1;
	wire [31:0] fork0x0_sum;
	assign fork0x0_sum_o0 = fork0x0_sum;
	assign fork0x0_sum_o1 = fork0x0_sum;


	/* -- JOIN(2) 0x0 -- */
	wire join0x0_valid_out;
	wire join0x0_stall_in;
	wire join0x0_valid_in0;
	wire join0x0_stall_out0;
	wire join0x0_valid_in1;
	wire join0x0_stall_out1;
	join2 join0x0(.valid_out(join0x0_valid_out),
	              .stall_in(join0x0_stall_in),
	              .valid_in0(join0x0_valid_in0),
	              .stall_out0(join0x0_stall_out0),
	              .valid_in1(join0x0_valid_in1),
	              .stall_out1(join0x0_stall_out1));
		/* -- data -- */
	wire [31:0] join0x0_sum_i0;
	wire [31:0] join0x0_sum_i1;
	wire [31:0] join0x0_sum;
	assign join0x0_sum = join0x0_sum_i1;
	wire [31:0] join0x0_value_i0;
	wire [31:0] join0x0_value_i1;
	wire [31:0] join0x0_value;
	assign join0x0_value = join0x0_value_i0;


	/* -- SELECT(2) 0x0 -- */
	wire select0x0_clk;
	wire select0x0_valid_out;
	wire select0x0_stall_in;
	wire select0x0_valid_in0;
	wire select0x0_stall_out0;
	wire select0x0_valid_in1;
	wire select0x0_stall_out1;
	wire [1:0] select0x0_selection;
	select2 select0x0(.clk(select0x0_clk), .reset(i_reset), .valid_out(select0x0_valid_out),
	                  .stall_in(select0x0_stall_in),
	                  .valid_in0(select0x0_valid_in0),
	                  .stall_out0(select0x0_stall_out0),
	                  .valid_in1(select0x0_valid_in1),
	                  .stall_out1(select0x0_stall_out1),
	                  .selection(select0x0_selection));
	assign select0x0_clk = i_clk;
		/* -- data -- */
	wire [31:0] select0x0_sum_i0;
	wire [31:0] select0x0_sum_i1;
	wire [31:0] select0x0_sum = select0x0_selection == 2'd1 ? select0x0_sum_i0 : (select0x0_sum_i1);
	wire [31:0] select0x0_value_i0;
	wire [31:0] select0x0_value_i1;
	wire [31:0] select0x0_value = select0x0_selection == 2'd1 ? select0x0_value_i0 : (select0x0_value_i1);


	/* -- FUNCTION accumulate -- */
	wire faccumulate_valid_in;
	wire faccumulate_stall_out;
	wire faccumulate_stall_int;
	wire faccumulate_valid_out0;
	wire faccumulate_stall_in0;
	wire faccumulate_condition0;
	function1 faccumulate(.clk(i_clk), .reset(i_reset), .valid_in(faccumulate_valid_in),
	                      .stall_out(faccumulate_stall_out),
	                      .stall_int(faccumulate_stall_int),
	                      .valid_out0(faccumulate_valid_out0),
	                      .stall_in0(faccumulate_stall_in0),
	                      .condition0(faccumulate_condition0));

	wire [31:0] faccumulate_sum_;
	wire [31:0] faccumulate_value_;
	wire [31:0] faccumulate_sum;
	wire [31:0] faccumulate_value;
	wire faccumulate_tSum;
	assign faccumulate_condition0 = faccumulate_tSum;
	wire faccumulate_tSum_valid_out = faccumulate_valid_out0;
	wire faccumulate_tSum_stall_in;
	assign faccumulate_stall_in0 = faccumulate_tSum_stall_in;
	assign faccumulate_stall_int = 0;
	reg [64:0] accumulate_xpita;
	always @ (*) accumulate_xpita = accumulate(faccumulate_sum,faccumulate_value);
	assign {faccumulate_tSum, faccumulate_sum_, faccumulate_value_} = accumulate_xpita;

	/* -- FUNCTION create_output -- */
	wire fcreate_output_valid_in;
	wire fcreate_output_stall_out;
	wire fcreate_output_stall_int;
	wire fcreate_output_valid_out0;
	wire fcreate_output_stall_in0;
	wire fcreate_output_condition0;
	function1 fcreate_output(.clk(i_clk), .reset(i_reset), .valid_in(fcreate_output_valid_in),
	                         .stall_out(fcreate_output_stall_out),
	                         .stall_int(fcreate_output_stall_int),
	                         .valid_out0(fcreate_output_valid_out0),
	                         .stall_in0(fcreate_output_stall_in0),
	                         .condition0(fcreate_output_condition0));

	wire [31:0] fcreate_output_sum_;
	wire [31:0] fcreate_output_sum_out_;
	wire [31:0] fcreate_output_sum;
	wire fcreate_output_tOutput;
	assign fcreate_output_condition0 = fcreate_output_tOutput;
	wire fcreate_output_tOutput_valid_out = fcreate_output_valid_out0;
	wire fcreate_output_tOutput_stall_in;
	assign fcreate_output_stall_in0 = fcreate_output_tOutput_stall_in;
	assign fcreate_output_stall_int = 0;
	reg [64:0] create_output_xpita;
	always @ (*) create_output_xpita = create_output(fcreate_output_sum);
	assign {fcreate_output_tOutput, fcreate_output_sum_, fcreate_output_sum_out_} = create_output_xpita;

	/* -- FUNCTION merge_sum -- */
	wire fmerge_sum_valid_in;
	wire fmerge_sum_stall_out;
	wire fmerge_sum_stall_int;
	wire fmerge_sum_valid_out0;
	wire fmerge_sum_stall_in0;
	wire fmerge_sum_condition0;
	function1 fmerge_sum(.clk(i_clk), .reset(i_reset), .valid_in(fmerge_sum_valid_in),
	                     .stall_out(fmerge_sum_stall_out),
	                     .stall_int(fmerge_sum_stall_int),
	                     .valid_out0(fmerge_sum_valid_out0),
	                     .stall_in0(fmerge_sum_stall_in0),
	                     .condition0(fmerge_sum_condition0));

	wire [31:0] fmerge_sum_sum_;
	wire [31:0] fmerge_sum_value_;
	wire [31:0] fmerge_sum_sum;
	wire [31:0] fmerge_sum_value;
	wire fmerge_sum_tSumReady;
	assign fmerge_sum_condition0 = fmerge_sum_tSumReady;
	wire fmerge_sum_tSumReady_valid_out = fmerge_sum_valid_out0;
	wire fmerge_sum_tSumReady_stall_in;
	assign fmerge_sum_stall_in0 = fmerge_sum_tSumReady_stall_in;
	assign fmerge_sum_stall_int = 0;
	reg [64:0] merge_sum_xpita;
	always @ (*) merge_sum_xpita = merge_sum(fmerge_sum_sum,fmerge_sum_value);
	assign {fmerge_sum_tSumReady, fmerge_sum_sum_, fmerge_sum_value_} = merge_sum_xpita;


	/* tSum */
	wire tSum_valid_out;
	wire tSum_stall_in;
	wire tSum_valid_in;
	wire tSum_stall_out;
	wire [31:0] tSum_data_in;
	wire [31:0] tSum_data_out;
	wire [31:0] tSum_sum = tSum_data_out[31:0];
	token_ff #(32) tSum(.clk(i_clk),
	                    .reset(i_reset),
	                    .valid_in(tSum_valid_in),
	                    .valid_out(tSum_valid_out),
	                    .stall_in(tSum_stall_in),
	                    .stall_out(tSum_stall_out),
	                    .data_in(tSum_data_in),
	                    .data_out(tSum_data_out));

	/* tSumReady */
	wire tSumReady_valid_out;
	wire tSumReady_stall_in;
	wire tSumReady_valid_in;
	wire tSumReady_stall_out;
	wire [63:0] tSumReady_data_in;
	wire [63:0] tSumReady_data_out;
	wire [31:0] tSumReady_sum = tSumReady_data_out[31:0];
	wire [31:0] tSumReady_value = tSumReady_data_out[63:32];
	token_ff #(64) tSumReady(.clk(i_clk),
	                         .reset(i_reset),
	                         .valid_in(tSumReady_valid_in),
	                         .valid_out(tSumReady_valid_out),
	                         .stall_in(tSumReady_stall_in),
	                         .stall_out(tSumReady_stall_out),
	                         .data_in(tSumReady_data_in),
	                         .data_out(tSumReady_data_out));

	/* tOutput */
	wire tOutput_valid_out;
	wire tOutput_stall_in;
	wire tOutput_valid_in;
	wire tOutput_stall_out;
	wire [31:0] tOutput_data_in;
	wire [31:0] tOutput_data_out;
	wire [31:0] tOutput_sum_out = tOutput_data_out[31:0];
	token_ff #(32) tOutput(.clk(i_clk),
	                       .reset(i_reset),
	                       .valid_in(tOutput_valid_in),
	                       .valid_out(tOutput_valid_out),
	                       .stall_in(tOutput_stall_in),
	                       .stall_out(tOutput_stall_out),
	                       .data_in(tOutput_data_in),
	                       .data_out(tOutput_data_out));
	assign o_tOutput_valid_out = tOutput_valid_out;
	assign tOutput_stall_in = i_tOutput_stall_in;

	/* tInput */
	wire tInput_valid_out;
	wire tInput_stall_in;
	assign tInput_valid_out = i_tInput_valid_in;
	assign o_tInput_stall_out = tInput_stall_in;

	/* tReset */
	wire tReset_valid_out;
	wire tReset_stall_in;
	assign tReset_valid_out = i_tReset_valid_in;
	assign o_tReset_stall_out = tReset_stall_in;

	/* --- CONTROL NETWORK --- */
	/* -- tSum -- */
	assign tSum_valid_in = faccumulate_tSum_valid_out;
	assign faccumulate_tSum_stall_in = tSum_stall_out;

	/* -- tSumReady -- */
	assign tSumReady_valid_in = fmerge_sum_tSumReady_valid_out;
	assign fmerge_sum_tSumReady_stall_in = tSumReady_stall_out;

	/* -- JOIN -- */
	assign join0x0_valid_in0 = tInput_valid_out;
	assign tInput_stall_in = join0x0_stall_out0;
	assign join0x0_valid_in1 = tSumReady_valid_out;
	assign tSumReady_stall_in = join0x0_stall_out1;

	/* -- <function create_output at 0xb7b923ac> -- */
	assign fcreate_output_valid_in = fork0x0_valid_out0;
	assign fork0x0_stall_in0 = fcreate_output_stall_out;

	/* -- tOutput -- */
	assign tOutput_valid_in = fcreate_output_tOutput_valid_out;
	assign fcreate_output_tOutput_stall_in = tOutput_stall_out;

	/* -- <function accumulate at 0xb7b92374> -- */
	assign faccumulate_valid_in = join0x0_valid_out;
	assign join0x0_stall_in = faccumulate_stall_out;

	/* -- SELECT -- */
	assign select0x0_valid_in0 = tReset_valid_out;
	assign tReset_stall_in = select0x0_stall_out0;
	assign select0x0_valid_in1 = fork0x0_valid_out1;
	assign fork0x0_stall_in1 = select0x0_stall_out1;

	/* -- <function merge_sum at 0xb7b9233c> -- */
	assign fmerge_sum_valid_in = select0x0_valid_out;
	assign select0x0_stall_in = fmerge_sum_stall_out;

	/* -- FORK -- */
	assign fork0x0_valid_in = tSum_valid_out;
	assign tSum_stall_in = fork0x0_stall_out;

	/* --- DATA NETWORK --- */
	/* -- tSum -- */
	// tSum
	assign tSum_data_in = {faccumulate_sum_};


	/* -- tSumReady -- */
	// tSumReady
	assign tSumReady_data_in = {fmerge_sum_value_, fmerge_sum_sum_};


	/* -- JOIN -- */
	// tInput -> join0x0
	assign join0x0_sum_i0 = sum;
	assign join0x0_value_i0 = value;
	// tSumReady -> join0x0
	assign join0x0_sum_i1 = tSumReady_sum;
	assign join0x0_value_i1 = tSumReady_value;

	/* -- <function create_output at 0xb7b923ac> -- */
	// fork0x0 -> fcreate_output
	assign fcreate_output_sum = fork0x0_sum_o0;

	/* -- tOutput -- */
	// tOutput
	assign tOutput_data_in = {fcreate_output_sum_out_};


	/* -- <function accumulate at 0xb7b92374> -- */
	// join0x0 -> faccumulate
	assign faccumulate_sum = join0x0_sum;
	assign faccumulate_value = join0x0_value;

	/* -- SELECT -- */
	// tReset -> select0x0
	assign select0x0_sum_i0 = sum;
	assign select0x0_value_i0 = value;
	// fork0x0 -> select0x0
	assign select0x0_sum_i1 = fork0x0_sum_o1;
	assign select0x0_value_i1 = 0;

	/* -- <function merge_sum at 0xb7b9233c> -- */
	// select0x0 -> fmerge_sum
	assign fmerge_sum_sum = select0x0_sum;
	assign fmerge_sum_value = select0x0_value;

	/* -- FORK -- */
	// tSum -> fork0x0
	assign fork0x0_sum = tSum_sum;



	assign o_sum_out = tOutput_sum_out;

`include "Accumulator.f.v"

endmodule
