module elasticROM(valid_in, stall_out, valid_out, stall_in, addr, data_out);
   
   parameter ADDRESS_WIDTH = 8;
   parameter DATA_WIDTH = 8;
   parameter DEPTH = 256;
   parameter FILE = "romdata.hex";

   input valid_in;
   output valid_out;
   input stall_in;
   output stall_out;

   input [ADDRESS_WIDTH-1:0] addr;
   output [DATA_WIDTH-1:0] data_out;

   reg [DATA_WIDTH-1:0] data [DEPTH-1:0];
   reg [DATA_WIDTH-1:0] data_out = 0;

   reg valid_out;
   reg stall_out;
   always @(addr or valid_in) begin
      data_out = #1 data[addr]; 
      valid_out = #1 valid_in;
      stall_out = 0;
   end

   // Model a consistent delay

/*   reg stall_out = 0;
   always @(valid_in) begin
      if( valid_in )
         stall_out <= 1;
      else if( stall_out )
         #10 stall_out <= 0;
   end*/

   // load file
   initial
      $readmemh(FILE, data);

endmodule
