
#include "stdio.h"                        
  #define PTS 4	    //# of points for FFT 

#define PI 3.14159265358979
typedef struct {short real,imag;} COMPLEX;
void FFT(COMPLEX *Y, short n);	    //FFT prototype
short i;               		    //general purpose index variable                  
 
COMPLEX w[PTS];       		    //twiddle constants stored in w 
COMPLEX samples[PTS];  		    //primary working buffer                                              

void print_sample();

char buf[256];

int main()
{
    
    printf("Hello World\n");

 for (i = 0 ; i<PTS ; i++)	    // set up twiddle constants in w 
  {
//   w[i].real = cos(2*PI*i/PTS); //Re component of twiddle constants
//   w[i].imag =-sin(2*PI*i/PTS); //Im component of twiddle constants
	w[i].real = 1;
	w[i].imag = 0;
  }
//8-FFT Wn initialization
/*w[0].real = 1; w[0].imag = 0;
  w[1].real = 0.707; w[1].imag = -0.707;
  w[2].real = 0; w[2].imag = -1;
  w[3].real = -0.707; w[3].imag = -0.707;  
*/ 
//end of 8-FFT Wn initialization

// 16-FFT Wn initialization
/*  w[0].real = 1; w[0].imag = 0;
  w[1].real = 0.923; w[1].imag = -0.38;
  w[2].real = 0.707; w[2].imag = -0.707;
  w[3].real = 0.38; w[3].imag = -0.92;
  w[4].real = 0; w[4].imag = -1;
  w[5].real = -0.38; w[5].imag = -0.92;

  w[6].real = -0.707; w[6].imag = -0.707;
  w[7].real = -0.923; w[7].imag = -0.38;
*/
//end of 16-FFT Wn initialization  

  for (i = 0; i<PTS/2; i++)
  {
    samples[i].real = 2;
    samples[i].imag = 0;
    samples[i+PTS/2].real = 0;
    samples[i+PTS/2].imag = 0;	
  }
  
  strcpy(buf, "before fft: ");
  print_sample();
  puts(buf);
    
 
  FFT(samples,PTS);              //call function FFT.c
   
  strcpy(buf, " after fft: ");
  print_sample();
  puts(buf);
   

}//end of main

void print_sample()
{
	short i;

	for(i =0; i< PTS; i++)
	{
		itoa(samples[i].real, &buf[12+4*i]);
        buf[12+4*i+1] = '+';
        itoa(samples[i].imag, &buf[12+4*i+2]);
        buf[12+4*i+3] = ',';
    }
    
    return ;
}

int
putchar(int ch)
{
    *((char *)0x0100) = (char)ch;
    return ch;
}


void FFT(COMPLEX *Y, short N)      //input sample array, # of points     
{
 COMPLEX temp1,temp2;             //temporary storage variables          
 short int i,j,k;                       //loop counter variables               
 short int upper_leg, lower_leg;   	    //index of upper/lower butterfly leg   
 short int leg_diff;                    //difference between upper/lower leg   
 short int num_stages = 0;              //number of FFT stages (iterations)
 short int index, step;                 //index/step through twiddle constant
 i = 1;                           //log(base2) of N points= # of stages  

 do
  {
   num_stages = num_stages + 1;
   i = i*2;
  }while (i!=N);
 
 leg_diff = N/2; 		     	    //difference between upper&lower legs     
 step = 1;

/*
 itoa(N, &buf[0],16);
 itoa(num_stages, &buf[1], 16);
 itoa(leg_diff, &buf[2],16);
 itoa(step, &buf[3],16);
 puts(buf);
*/

// for (i = 0;i < num_stages; i++)  //for N-point FFT          
 for (i = 0;i < num_stages; i++)  //for N-point FFT                 
  {
   index = 0;
   for (j = 0; j < leg_diff; j++)
    {
     for (upper_leg = j; upper_leg < N; upper_leg += (2*leg_diff))
      {   
       lower_leg = upper_leg+leg_diff;
       
 /*      puts("xxxxx");
       itoa(upper_leg, &buf[0],16);
       buf[1] = ',';
       itoa(lower_leg, &buf[2],16);
       buf[3] = ',';
       puts(buf);
 
       itoa((Y[upper_leg]).real, &buf[0],16);
       buf[1] = ',';
       itoa((Y[upper_leg]).imag, &buf[2],16);
       buf[3] = ',';
       puts(buf);
       itoa((Y[lower_leg]).real, &buf[0],16);
       buf[1] = ',';
       itoa((Y[lower_leg]).imag, &buf[2],16);
       buf[3] = ',';
       puts(buf);
   */    
    
       temp1.real = (Y[upper_leg]).real + (Y[lower_leg]).real;
       temp1.imag = (Y[upper_leg]).imag + (Y[lower_leg]).imag;
       temp2.real = (Y[upper_leg]).real - (Y[lower_leg]).real;
       temp2.imag = (Y[upper_leg]).imag - (Y[lower_leg]).imag;
  /*    
       puts("temp1 and temp2");
       itoa(temp1.real, &buf[0],16);
       buf[1] = ',';
       itoa(temp1.imag, &buf[2],16);
       buf[3] = ',';
       puts(buf);
       itoa(temp2.real, &buf[0],16);
       buf[1] = ',';
       itoa(temp2.imag, &buf[2],16);
       buf[3] = ',';
       puts(buf);
   */    
       
       (Y[lower_leg]).real = temp2.real*(w[index]).real - temp2.imag*(w[index]).imag;
       (Y[lower_leg]).imag = temp2.real*(w[index]).imag + temp2.imag*(w[index]).real;
       (Y[upper_leg]).real = temp1.real;
       (Y[upper_leg]).imag = temp1.imag;

    /*    puts("after:");
       itoa((Y[upper_leg]).real, &buf[0],16);
       buf[1] = ',';
       itoa((Y[upper_leg]).imag, &buf[2],16);
       buf[3] = ',';
       puts(buf);
       itoa((Y[lower_leg]).real, &buf[0],16);
       buf[1] = ',';
       itoa((Y[lower_leg]).imag, &buf[2],16);
       buf[3] = ',';
       puts(buf);
*/
             
      }
     index += step;

    }
    
    leg_diff = leg_diff/2;
    step = step * 2;
 }
 
 j = 0;
 for (i = 1; i < (N-1); i++)     //bit reversal for resequencing data
 {
   k = N/2;
   while (k <= j)
   {
     j = j - k;
     k = k/2;
   }
   j = j + k;
   if (i<j)
   {
       temp1.real = (Y[j]).real;
       temp1.imag = (Y[j]).imag;
       (Y[j]).real = (Y[i]).real;
       (Y[j]).imag = (Y[i]).imag;
       (Y[i]).real = temp1.real;
       (Y[i]).imag = temp1.imag;
    }
 }
 
  printf("FFTDONE\n");
  return;
}
