
from Int import Int


class Instruction:
	def __init__(self):
		self.size = 48
		
	def __size__(self):
	   return self.size
   
	def __coherence__(self):
		return "none"
	
	
	# single operand instructions
	def single_opcode(self, size=3):
		return self[7:10]

	def single_bw(self, size=1):
		return self[6]
	
	def single_ad(self, size=2):
		return self[4:6]
	
	def single_dsreg(self, size=4):
		return self[0:4]
	
	def is_single(self, size=1):
		return self[10:16] == Int(6, 4)
	

	# double operand instructions
	def double_opcode(self, size=4):
		return self[12:16]

	def double_sreg(self, size=4):
		return self[8:12]
	
	def double_ad(self, size=1):
		return self[7]
	
	def double_bw(self, size=1):
		return self[6]
	
	def double_as(self, size=2):
		return self[4:6]
	
	def double_dreg(self, size=4):
		return self[0:4]
	
	def is_double(self, size=1):
		return self[14] or self[15]
	
	
	# jump instructions
	def jump_opcode(self, size=3):
		return self[13:16]

	def jump_c(self, size=3):
		return self[10:13]
	
	def jump_offset(self, size=16):
		return (self[0:10] << 1) | \
			   (self[9] << 11) | \
			   (self[9] << 12) | \
			   (self[9] << 13) | \
			   (self[9] << 14) | \
			   (self[9] << 15) \

	def is_jump(self, size=1):
		return self[13:16] == Int(3, 1)

	
	# extension words
	def extension1(self, size=16):
		return self[16:32]
		
	def extension2(self, size=16):
		return self[32:48]
		
		
	
	
	