/* --- Instruction_single_dsreg --- */
function [3:0] Instruction_single_dsreg;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_single_dsreg = _self[3:0];
end
endfunction

/* --- Instruction_is_single --- */
function Instruction_is_single;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_is_single = _self[15:10] == 6'd4;
end
endfunction

/* --- Instruction_jump_c --- */
function [2:0] Instruction_jump_c;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_jump_c = _self[12:10];
end
endfunction

/* --- Instruction_jump_opcode --- */
function [2:0] Instruction_jump_opcode;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_jump_opcode = _self[15:13];
end
endfunction

/* --- Instruction_single_opcode --- */
function [2:0] Instruction_single_opcode;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_single_opcode = _self[9:7];
end
endfunction

/* --- Instruction_is_jump --- */
function Instruction_is_jump;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_is_jump = _self[15:13] == 3'd1;
end
endfunction

/* --- Instruction_extension2 --- */
function [15:0] Instruction_extension2;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_extension2 = _self[47:32];
end
endfunction

/* --- Instruction_extension1 --- */
function [15:0] Instruction_extension1;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_extension1 = _self[31:16];
end
endfunction

/* --- Instruction_single_bw --- */
function Instruction_single_bw;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_single_bw = _self[6];
end
endfunction

/* --- Instruction_is_double --- */
function Instruction_is_double;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_is_double = (_self[14] | _self[15]);
end
endfunction

/* --- Instruction_double_bw --- */
function Instruction_double_bw;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_double_bw = _self[6];
end
endfunction

/* --- Instruction_double_dreg --- */
function [3:0] Instruction_double_dreg;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_double_dreg = _self[3:0];
end
endfunction

/* --- Instruction_double_sreg --- */
function [3:0] Instruction_double_sreg;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_double_sreg = _self[11:8];
end
endfunction

/* --- Instruction_double_opcode --- */
function [3:0] Instruction_double_opcode;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_double_opcode = _self[15:12];
end
endfunction

/* --- Instruction_double_ad --- */
function Instruction_double_ad;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_double_ad = _self[7];
end
endfunction

/* --- Instruction_jump_offset --- */
function [15:0] Instruction_jump_offset;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_jump_offset = ((_self[9:0] << 10'd1) | (_self[9] << 10'd11) | (_self[9] << 10'd12) | (_self[9] << 10'd13) | (_self[9] << 10'd14) | (_self[9] << 10'd15));
end
endfunction

/* --- Instruction_single_ad --- */
function [1:0] Instruction_single_ad;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_single_ad = _self[5:4];
end
endfunction

/* --- Instruction_double_as --- */
function [1:0] Instruction_double_as;
input [47:0] _self;

// local storage

begin
	// begin functional code

	Instruction_double_as = _self[5:4];
end
endfunction

