module function3(clk, reset, stall_int, valid_in, valid_out0, valid_out1, valid_out2, stall_out, stall_in0, stall_in1, stall_in2, condition0, condition1, condition2);
	input clk;
	input reset;
	input stall_int;
	input valid_in;
	input stall_in0;
	input stall_in1;
	input stall_in2;
	input condition0;
	input condition1;
	input condition2;
	output stall_out;
	output valid_out0;
	output valid_out1;
	output valid_out2;

	reg hold0;
	reg hold1;
	reg hold2;

	wire stall0_ = stall_in0 & hold0;
	wire stall1_ = stall_in1 & hold1;
	wire stall2_ = stall_in2 & hold2;
	assign stall_out = stall_int | (stall0_ & condition0) | (stall1_ & condition1) | (stall2_ & condition2);
	assign valid_out0 = condition0 & hold0 & valid_in;
	assign valid_out1 = condition1 & hold1 & valid_in;
	assign valid_out2 = condition2 & hold2 & valid_in;

	always @ (posedge clk) begin
		if (!reset) begin
			hold0 <= 0;
			hold1 <= 0;
			hold2 <= 0;
		end
		else begin
			hold0 <= ~(valid_in & stall_out) | stall0_ | ~condition0;
			hold1 <= ~(valid_in & stall_out) | stall1_ | ~condition1;
			hold2 <= ~(valid_in & stall_out) | stall2_ | ~condition2;
		end
	end
endmodule
