module function5(clk, reset, stall_int, valid_in, valid_out0, valid_out1, valid_out2, valid_out3, valid_out4, stall_out, stall_in0, stall_in1, stall_in2, stall_in3, stall_in4, condition0, condition1, condition2, condition3, condition4);
	input clk;
	input reset;
	input stall_int;
	input valid_in;
	input stall_in0;
	input stall_in1;
	input stall_in2;
	input stall_in3;
	input stall_in4;
	input condition0;
	input condition1;
	input condition2;
	input condition3;
	input condition4;
	output stall_out;
	output valid_out0;
	output valid_out1;
	output valid_out2;
	output valid_out3;
	output valid_out4;

	reg hold0;
	reg hold1;
	reg hold2;
	reg hold3;
	reg hold4;

	wire stall0_ = stall_in0 & hold0;
	wire stall1_ = stall_in1 & hold1;
	wire stall2_ = stall_in2 & hold2;
	wire stall3_ = stall_in3 & hold3;
	wire stall4_ = stall_in4 & hold4;
	assign stall_out = stall_int | (stall0_ & condition0) | (stall1_ & condition1) | (stall2_ & condition2) | (stall3_ & condition3) | (stall4_ & condition4);
	assign valid_out0 = condition0 & hold0 & valid_in;
	assign valid_out1 = condition1 & hold1 & valid_in;
	assign valid_out2 = condition2 & hold2 & valid_in;
	assign valid_out3 = condition3 & hold3 & valid_in;
	assign valid_out4 = condition4 & hold4 & valid_in;

	always @ (posedge clk) begin
		if (!reset) begin
			hold0 <= 0;
			hold1 <= 0;
			hold2 <= 0;
			hold3 <= 0;
			hold4 <= 0;
		end
		else begin
			hold0 <= ~(valid_in & stall_out) | stall0_ | ~condition0;
			hold1 <= ~(valid_in & stall_out) | stall1_ | ~condition1;
			hold2 <= ~(valid_in & stall_out) | stall2_ | ~condition2;
			hold3 <= ~(valid_in & stall_out) | stall3_ | ~condition3;
			hold4 <= ~(valid_in & stall_out) | stall4_ | ~condition4;
		end
	end
endmodule
