module select2(clk, reset, valid_out, valid_in0, valid_in1, stall_in, stall_out0, stall_out1, selection);
	input clk;
	input reset;
	input stall_in;
	input valid_in0;
	input valid_in1;
	output valid_out;
	output stall_out0;
	output stall_out1;
	output [1:0] selection;
	reg [1:0] hsel;
	wire [1:0] next_selection;

	reg hold;
	assign valid_out = valid_in0 | valid_in1;
	wire [1:0] selection = hold ? hsel : next_selection;

	assign next_selection = valid_in0 ? 2'd1 : (2'd2);

	assign stall_out0 = valid_in0 & (stall_in | ~selection[0]);
	assign stall_out1 = valid_in1 & (stall_in | ~selection[1]);

	
	always @ (posedge clk) begin
		if (!reset) begin
			hold <= 1'b0;
		end
		else begin
			if (!valid_out || !stall_in) begin
				hold <= 1'b0;
			end
			else begin
				if (!hold)
					hsel <= next_selection;
				hold <= 1'b1;
			end
		end
	end
endmodule
