module select3(clk, reset, valid_out, valid_in0, valid_in1, valid_in2, stall_in, stall_out0, stall_out1, stall_out2, selection);
	input clk;
	input reset;
	input stall_in;
	input valid_in0;
	input valid_in1;
	input valid_in2;
	output valid_out;
	output stall_out0;
	output stall_out1;
	output stall_out2;
	output [2:0] selection;
	reg [2:0] hsel;
	wire [2:0] next_selection;

	reg hold;
	assign valid_out = valid_in0 | valid_in1 | valid_in2;
	wire [2:0] selection = hold ? hsel : next_selection;

	assign next_selection = valid_in0 ? 3'd1 : (valid_in1 ? 3'd2 : (3'd4));

	assign stall_out0 = valid_in0 & (stall_in | ~selection[0]);
	assign stall_out1 = valid_in1 & (stall_in | ~selection[1]);
	assign stall_out2 = valid_in2 & (stall_in | ~selection[2]);

	
	always @ (posedge clk) begin
		if (!reset) begin
			hold <= 1'b0;
		end
		else begin
			if (!valid_out || !stall_in) begin
				hold <= 1'b0;
			end
			else begin
				if (!hold)
					hsel <= next_selection;
				hold <= 1'b1;
			end
		end
	end
endmodule
