module select4(clk, reset, valid_out, valid_in0, valid_in1, valid_in2, valid_in3, stall_in, stall_out0, stall_out1, stall_out2, stall_out3, selection);
	input clk;
	input reset;
	input stall_in;
	input valid_in0;
	input valid_in1;
	input valid_in2;
	input valid_in3;
	output valid_out;
	output stall_out0;
	output stall_out1;
	output stall_out2;
	output stall_out3;
	output [3:0] selection;
	reg [3:0] hsel;
	wire [3:0] next_selection;

	reg hold;
	assign valid_out = valid_in0 | valid_in1 | valid_in2 | valid_in3;
	wire [3:0] selection = hold ? hsel : next_selection;

	assign next_selection = valid_in0 ? 4'd1 : (valid_in1 ? 4'd2 : (valid_in2 ? 4'd4 : (4'd8)));

	assign stall_out0 = valid_in0 & (stall_in | ~selection[0]);
	assign stall_out1 = valid_in1 & (stall_in | ~selection[1]);
	assign stall_out2 = valid_in2 & (stall_in | ~selection[2]);
	assign stall_out3 = valid_in3 & (stall_in | ~selection[3]);

	
	always @ (posedge clk) begin
		if (!reset) begin
			hold <= 1'b0;
		end
		else begin
			if (!valid_out || !stall_in) begin
				hold <= 1'b0;
			end
			else begin
				if (!hold)
					hsel <= next_selection;
				hold <= 1'b1;
			end
		end
	end
endmodule
