module select6(clk, reset, valid_out, valid_in0, valid_in1, valid_in2, valid_in3, valid_in4, valid_in5, stall_in, stall_out0, stall_out1, stall_out2, stall_out3, stall_out4, stall_out5, selection);
	input clk;
	input reset;
	input stall_in;
	input valid_in0;
	input valid_in1;
	input valid_in2;
	input valid_in3;
	input valid_in4;
	input valid_in5;
	output valid_out;
	output stall_out0;
	output stall_out1;
	output stall_out2;
	output stall_out3;
	output stall_out4;
	output stall_out5;
	output [5:0] selection;
	reg [5:0] hsel;
	wire [5:0] next_selection;

	reg hold;
	assign valid_out = valid_in0 | valid_in1 | valid_in2 | valid_in3 | valid_in4 | valid_in5;
	wire [5:0] selection = hold ? hsel : next_selection;

	assign next_selection = valid_in0 ? 6'd1 : (valid_in1 ? 6'd2 : (valid_in2 ? 6'd4 : (valid_in3 ? 6'd8 : (valid_in4 ? 6'd16 : (6'd32)))));

	assign stall_out0 = valid_in0 & (stall_in | ~selection[0]);
	assign stall_out1 = valid_in1 & (stall_in | ~selection[1]);
	assign stall_out2 = valid_in2 & (stall_in | ~selection[2]);
	assign stall_out3 = valid_in3 & (stall_in | ~selection[3]);
	assign stall_out4 = valid_in4 & (stall_in | ~selection[4]);
	assign stall_out5 = valid_in5 & (stall_in | ~selection[5]);

	
	always @ (posedge clk) begin
		if (!reset) begin
			hold <= 1'b0;
		end
		else begin
			if (!valid_out || !stall_in) begin
				hold <= 1'b0;
			end
			else begin
				if (!hold)
					hsel <= next_selection;
				hold <= 1'b1;
			end
		end
	end
endmodule
